# Class RandomRowSplittable

java.lang.Object
uk.ac.starlink.table.RandomRowSplittable

All Implemented Interfaces:
  `Closeable, AutoCloseable, RowData, RowSequence, RowSplittable, uk.ac.starlink.util.Sequence, uk.ac.starlink.util.Splittable<RowSplittable>`

public class RandomRowSplittable extends Object implements RowSplittable
RowSplittable based on a RowAccess.

Since:
  4 Aug 2020
Author:
  Mark Taylor

## Constructor Summary

Constructors
Constructor
Description
`RandomRowSplittable(StarTable table)`
Constructs a splittable for a given table.

## Method Summary

Modifier and Type
Method
Description
`void`
`close()`
Indicates that this sequence will not be required any more.
`Object`
`getCell(int icol)`
Returns the contents of a cell in the current row.
`Object[]`
`getRow()`
Returns the contents of the current table row, as an array with the same number of elements as there are columns in this table.
`boolean`
`next()`
Attempts to advance the current row to the next one.
`LongSupplier`
`rowIndex()`
Returns a supplier for the index of the row currently being processed, if possible.
`RandomRowSplittable`
`split()`
`long`
`splittableSize()`

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### RandomRowSplittable

public RandomRowSplittable(StarTable table) throws IOException
Constructs a splittable for a given table.

Parameters:
  `table` - random-access table
Throws:
  `UnsupportedOperationException` - if table is not random-access
  `IOException`

## Method Details

### splittableSize

public long splittableSize()

Specified by:
  `splittableSize` in interface `uk.ac.starlink.util.Splittable<RowSplittable>`

### split

public RandomRowSplittable split()

Specified by:
  `split` in interface `uk.ac.starlink.util.Splittable<RowSplittable>`

### rowIndex

public LongSupplier rowIndex()
Description copied from interface: `RowSplittable`
Returns a supplier for the index of the row currently being processed, if possible. The row index is a global value; when accessing the first row of a top-level RowSplittable, the value returned by this supplier should be the first index in the table. But for objects resulting from splitting a top-level instance into sub-instances, the return value should reflect the index in the original sequence of rows; each index should be returned from only one of the splittables resulting from splitting a top-level instance.

Typically, the row index will start at 0 and increment for each row, but the numbering may be different depending on the requirements of the implementation or usage.

Before the `RowSequence.next()` method has been called, the return value will be one less than the first row index. After `RowSequence.next` has returned false, the value is undefined.

Depending on the implementation, it may not be possible to determine the row index (for instance if the sequence is split into sub-splittables of unknown size). In such cases, this method returns null. The null-ness of the return value must be the same for all instances of the splittable hierarchy for a given sequence, so don't return a non-null value for the first splittable and then null values for some or all of its children.

Specified by:
  `rowIndex` in interface `RowSplittable`
Returns:
  supplier for the globally-referenced row index value of the current row of this sequence, or null

### next

public boolean next() throws IOException
Description copied from interface: `RowSequence`
Attempts to advance the current row to the next one. If `true` is returned the attempt has been successful, and if `false` is returned there are no more rows in this sequence. Since the initial position of a RowSequence is before the first row, this method must be called before current row data can be accessed using the `RowSequence.getCell(int)` or `RowSequence.getRow()` methods.

Specified by:
  `next` in interface `RowSequence`
Specified by:
  `next` in interface `uk.ac.starlink.util.Sequence`
Returns:
  `true` iff this sequence has been advanced to the next row
Throws:
  `IOException` - if there is some error

### getCell

public Object getCell(int icol) throws IOException
Description copied from interface: `RowSequence`
Returns the contents of a cell in the current row. The class of the returned object should be the same as, or a subclass of, the class returned by `getColumnInfo(icol).getContentClass()`. An unchecked exception will be thrown if there is no current row (`next` has not yet been called).

Specified by:
  `getCell` in interface `RowData`
Specified by:
  `getCell` in interface `RowSequence`
Parameters:
  `icol` - column index
Returns:
  the contents of cell `icol` in the current row
Throws:
  `IOException` - if there is an error reading the data

### getRow

public Object[] getRow() throws IOException
Description copied from interface: `RowSequence`
Returns the contents of the current table row, as an array with the same number of elements as there are columns in this table. An unchecked exception will be thrown if there is no current row (`next` has not yet been called).

Specified by:
  `getRow` in interface `RowData`
Specified by:
  `getRow` in interface `RowSequence`
Returns:
  an array of the objects in each cell in row `irow`
Throws:
  `IOException` - if there is an error reading the data

### close

public void close() throws IOException
Description copied from interface: `RowSequence`
Indicates that this sequence will not be required any more. This should release resources associated with this object. The effect of calling any of the other methods following a `close` is undefined.

Specified by:
  `close` in interface `AutoCloseable`
Specified by:
  `close` in interface `Closeable`
Specified by:
  `close` in interface `RowSequence`
Throws:
  `IOException`